#ifndef LEVEL1_HASH_TABLE
#define LEVEL1_HASH_TABLE

#include <linux/config.h>
#include <linux/module.h>
#include <linux/kernel.h>
#include <linux/init.h>
#include <linux/security.h>
#include <linux/gfp.h>
#include <linux/namei.h>
#include "umb_types.h"

/* Alloc memory for the hash_table */
hashptr hash_table_create(void);

/* Free memory for the hash table and all elements */
void hash_table_destroy(hashptr table);

/* Inserts a restriction to the hash table */
int hash_table_insert(hashptr table, char *string);

/* Check if a string has a match in the hashtable */ 
int hash_exists(hashptr table, char *path);

/* Development/debug printing function for hash tables */
void hash_table_print(hashptr table);

#endif
